

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// class `SeqD<T>': Provides convenient syntax for building small      //
//                  vectors                                            //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //


template<class T>
class Seq1 {
  T els [1] ;
public :
  Seq1(T el1) {
    els [0] = el1 ;
  }
  operator T*() {return els ; } ;
} ;

template<class T>
class Seq2 {
  T els [2] ;
public :
  Seq2(T el1, T el2) {
    els [0] = el1 ;
    els [1] = el2 ;
  }
  operator T*() {return els ; } ;
} ;

template<class T>
class Seq3 {
  T els [3] ;
public :
  Seq3(T el1, T el2, T el3) {
    els [0] = el1 ;
    els [1] = el2 ;
    els [2] = el3 ;
  }
  operator T*() {return els ; } ;
} ;

template<class T>
class Seq4 {
  T els [4] ;
public :
  Seq4(T el1, T el2, T el3, T el4) {
    els [0] = el1 ;
    els [1] = el2 ;
    els [2] = el3 ;
    els [3] = el4 ;
  }
  operator T*() {return els ; } ;
} ;


template<class T>
inline Seq1<T> seq(T el1) {return Seq1<T>(el1) ; }

template<class T>
inline Seq2<T> seq(T el1, T el2) {return Seq2<T>(el1, el2) ; }

template<class T>
inline Seq3<T> seq(T el1, T el2, T el3) {return Seq3<T>(el1, el2, el3) ; }

template<class T>
inline Seq4<T> seq(T el1, T el2, T el3, T el4) {
  return Seq4<T>(el1, el2, el3, el4) ;
}

